<?php

/**
 * Test: Overriding class of service definition defined in CompilerExtension.
 *
 * @author     David Grudl
 * @package    Nette\Config
 */

use Nette\Config\Configurator,
	Nette\Config\Compiler,
	Nette\DI\ContainerBuilder;


require __DIR__ . '/../bootstrap.php';


class Factory
{
	static function createLorem($arg = NULL)
	{
		return new Lorem($arg);
	}
}


class IpsumFactory
{
	static function create($arg = NULL)
	{
		return new Ipsum($arg);
	}
}


class Lorem
{
	function __construct($arg = NULL)
	{
		Notes::add(__METHOD__ . ' ' . $arg);
	}
}

class Ipsum
{
	function __construct($arg = NULL)
	{
		Notes::add(__METHOD__ . ' ' . $arg);
	}
}


class FooExtension extends Nette\Config\CompilerExtension
{

	public function loadConfiguration()
	{
		$container = $this->getContainerBuilder();
		$container->parameters['class'] = 'Lorem';

		$container->addDefinition('one1')
			->setClass('%class%', array(1));
		$container->addDefinition('one2')
			->setClass('%class%', array(1));
		$container->addDefinition('one3')
			->setClass('%class%', array(1));
		$container->addDefinition('one4')
			->setClass('%class%', array(1));
		$container->addDefinition('one5')
			->setClass('%class%', array(1));
		$container->addDefinition('one6')
			->setClass('%class%', array(1));
		$container->addDefinition('one7')
			->setClass('%class%', array(1));

		$container->addDefinition('two1')
			->setClass('Lorem')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('two2')
			->setClass('Lorem')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('two3')
			->setClass('Lorem')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('two4')
			->setClass('Lorem')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('two5')
			->setClass('Lorem')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('two6')
			->setClass('Lorem')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('two7')
			->setClass('Lorem')
			->setFactory('Factory::createLorem', array(1));

		$container->addDefinition('three1')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('three2')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('three3')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('three4')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('three5')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('three6')
			->setFactory('Factory::createLorem', array(1));
		$container->addDefinition('three7')
			->setFactory('Factory::createLorem', array(1));
	}

}


$configurator = new Configurator;
$configurator->setTempDirectory(TEMP_DIR);
$configurator->onCompile[] = function(Configurator $configurator, Compiler $compiler){
	$compiler->addExtension('database', new FooExtension);
};
$container = $configurator->addConfig(__DIR__ . '/files/config.extensionOverride.neon', Configurator::NONE)
	->createContainer();

Assert::type( 'Ipsum', $container->getService('one1') );
Assert::same(array(
	'Ipsum::__construct ',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('one2') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('one3') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());

Assert::type( 'Lorem', $container->getService('one4') );
Assert::same(array(
	'Lorem::__construct 2',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('one5') );
Assert::same(array(
	'Ipsum::__construct ',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('one6') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('one7') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());


Assert::type( 'Ipsum', $container->getService('two1') );
Assert::same(array(
	'Ipsum::__construct ',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('two2') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('two3') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());

Assert::type( 'Lorem', $container->getService('two4') );
Assert::same(array(
	'Lorem::__construct 2',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('two5') );
Assert::same(array(
	'Ipsum::__construct ',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('two6') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('two7') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());


Assert::type( 'Ipsum', $container->getService('three1') );
Assert::same(array(
	'Ipsum::__construct ',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('three2') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('three3') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());

Assert::type( 'Lorem', $container->getService('three4') );
Assert::same(array(
	'Lorem::__construct 2',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('three5') );
Assert::same(array(
	'Ipsum::__construct ',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('three6') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());

Assert::type( 'Ipsum', $container->getService('three7') );
Assert::same(array(
	'Ipsum::__construct 2',
), Notes::fetch());
